

/**
 *流程状态
 */
function getProcessStateTxt(processid){
    if (processid == '1') {
        return '新建评估';
    } else if (processid == '2') {
        return '实审重估';
    } else if (processid == '3') {
        return '转当评估';
    } else {
        return '新建评估';
    }
}

/**
 *用户实名认证状态 
 */
function getUserVerifiedStatusTxt(verifiedStatus){
    if (verifiedStatus == 3) {
        return '未通过';
    } else if (verifiedStatus == 1) {
        return '认证中';
    } else if (verifiedStatus == 2) {
        return '已认证';
    } else {
        return '未认证';
    }
}

/**
 *用户评估专家认证状态 
 */
function getUserVerifiedPgzjStatusTxt(verifiedPgzjStatus){
    if (verifiedPgzjStatus == 0) {
        return '未认证';
    } else if (verifiedPgzjStatus == 1) {
        return '认证中';
    } else if (verifiedPgzjStatus == 2) {
        return '已认证';
    } else {
        return '未认证';
    }
}


/**
 *评估状态 
 */
function getAssessStatusTxt(status){
    if (status == '1') {
        return '待评估';
    } else if (status == '2') {
        return '已过期';
    } else if (status == '3') {
        return '待补充';
    } else if (status == '4') {
        return '评估中';
    } else if (status == '5') {
        return '待确认';
    } else if (status == '6') {
        return '已入库';
    } else if (status == '7') {
        return '已拒收';
    } else if (status == '8') {
        return '已取消';
    }
}


/**
 *用户类型 
 */
function getUserRoleTxt(role){
    if (role == '2') {
        return '评估师';
    } else {
        return '普通';
    }
}


/**
 * 去除空格
 */
function noSpace (txt) {
	if (!txt) {
		return '';
	} 
	return txt.replace(/\s+/g, "");
}

/**
 *金额格式处理
 */
function parseMoney(str, def) {
	if(typeof def == "undefined") def = 0;
	var m = parseFloat(str);
	if(isNaN(m) || m == "") m = def;
	if(typeof m == "number") m = m.toFixed(2);
	return m;
}

/**
 * 银行卡验证
 */
function isBankNo(bankno){
	if (bankno.length < 16 || bankno.length > 19) {
		//$("#banknoInfo").html("银行卡号长度必须在16到19之间");
		return false;
	}
	var num = /^\d*$/;  //全数字
	if (!num.exec(bankno)) {
		//$("#banknoInfo").html("银行卡号必须全为数字");
		return false;
	}
	//开头6位
	var strBin="10,18,30,35,37,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,58,60,62,65,68,69,84,87,88,94,95,98,99";    
	if (strBin.indexOf(bankno.substring(0, 2))== -1) {
		//$("#banknoInfo").html("银行卡号开头6位不符合规范");
		return false;
	}
    var lastNum=bankno.substr(bankno.length-1,1);//取出最后一位（与luhm进行比较）

    var first15Num=bankno.substr(0,bankno.length-1);//前15或18位
    var newArr=new Array();
    for(var i=first15Num.length-1;i>-1;i--){    //前15或18位倒序存进数组
        newArr.push(first15Num.substr(i,1));
    }
    var arrJiShu=new Array();  //奇数位*2的积 <9
    var arrJiShu2=new Array(); //奇数位*2的积 >9
    
    var arrOuShu=new Array();  //偶数位数组
    for(var j=0;j<newArr.length;j++){
        if((j+1)%2==1){//奇数位
            if(parseInt(newArr[j])*2<9)
            arrJiShu.push(parseInt(newArr[j])*2);
            else
            arrJiShu2.push(parseInt(newArr[j])*2);
        }
        else //偶数位
        arrOuShu.push(newArr[j]);
    }
    
    var jishu_child1=new Array();//奇数位*2 >9 的分割之后的数组个位数
    var jishu_child2=new Array();//奇数位*2 >9 的分割之后的数组十位数
    for(var h=0;h<arrJiShu2.length;h++){
        jishu_child1.push(parseInt(arrJiShu2[h])%10);
        jishu_child2.push(parseInt(arrJiShu2[h])/10);
    }        
    
    var sumJiShu=0; //奇数位*2 < 9 的数组之和
    var sumOuShu=0; //偶数位数组之和
    var sumJiShuChild1=0; //奇数位*2 >9 的分割之后的数组个位数之和
    var sumJiShuChild2=0; //奇数位*2 >9 的分割之后的数组十位数之和
    var sumTotal=0;
    for(var m=0;m<arrJiShu.length;m++){
        sumJiShu=sumJiShu+parseInt(arrJiShu[m]);
    }
    
    for(var n=0;n<arrOuShu.length;n++){
        sumOuShu=sumOuShu+parseInt(arrOuShu[n]);
    }
    
    for(var p=0;p<jishu_child1.length;p++){
        sumJiShuChild1=sumJiShuChild1+parseInt(jishu_child1[p]);
        sumJiShuChild2=sumJiShuChild2+parseInt(jishu_child2[p]);
    }      
    //计算总和
    sumTotal=parseInt(sumJiShu)+parseInt(sumOuShu)+parseInt(sumJiShuChild1)+parseInt(sumJiShuChild2);
    
    //计算Luhm值
    var k= parseInt(sumTotal)%10==0?10:parseInt(sumTotal)%10;        
    var luhm= 10-k;
    
    if(lastNum==luhm){
    $("#banknoInfo").html("Luhm验证通过");
    return true;
    }
    else{
    $("#banknoInfo").html("银行卡号必须符合Luhm校验");
    return false;
    }        
}

/**
 * 检查真实姓名
 */
function isActualName(actualname){
    if (!actualname) return false;
    actualname =  actualname.trim();
    var myreg = /^[\u4e00-\u9fa5]{2,6}$/;
    if(myreg.test(actualname)) {
        return true;
    } else {
        return false;
    }
}

/**
 * 检查电话号
 */
function isTelePhone(phone){
  if (!phone) return false; 
  phone =  phone.trim();
  
  var myreg = /^([0-9]{3,4}-)?[0-9]{7,8}$/;
  if(myreg.test(phone)) {
		return true;
  } else {
		return false;
  }	
}

/**
 * 检查手机号
 */
function isPhone(phone){
  if (!phone) return false; 
  var myreg = /^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/;
  if(myreg.test(phone)) {
		return true;
  } else {
		return false;
  }	
}

/**
 * 检查身份证
 */
function isIdCard(idcard){
	if (!idcard) {
		return false;
	} else if (idcard.length<15) {
		return false;
	}
	idcard = idcard.toUpperCase();
	var bo=/^(\d{6})(18|19|20)?(\d{2})([01]\d)([0123]\d)(\d{3})(\d|X)?$/.test(idcard);
	//var year = idcard. substr(6,4);
	var month = idcard. substr(10,2);
	var day = idcard. substr(12,2);
	
	if(bo==true && month<=12 && day<=31 && (idcard.length==18 || idcard.length==15)){
		return true;
	} else {
		return false;
	}
}

/**
 *检查邮箱 
 */
function isEmail(email) {
	var re = /^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/;
	if(re.test(email)){
		return true;
	}else{
		return false;
	}
}

/**
 *检查用户名
 */
function isLoginName(name) {
	var username = $.trim(name);
	if(!username) {
		return 0;
	} else if( /^\d.*$/.test( username ) ){
		//用户名不能以数字开头
		return -1;
	} else if(username.length<3 || username.length>22 ){
		//合法长度为3-22个字符
		return -2;
	} else if(! /^\w+$/.test( username ) ){
		//用户名只能包含_,英文字母，数字
		return -3;
	} else if(! /^([a-z]|[A-Z])[0-9a-zA-Z_]+$/.test( username ) ){
		//用户名只能英文字母开头
		return -4;
	} else if(!(/[0-9a-zA-Z]+$/.test( username ))){
		//用户名只能英文字母或数字结尾
		return -5;
	}
	return 1;
}

/**
 * 获得用户名提示
 */
function getLoginNamePoint(floag) {
	var floag2 = $.trim(floag);
	if(!floag2) {
		return '';
	} else if(floag2 == '-1'){
		return '用户名不能以数字开头';
	} else if(floag2 == '-2' ){
		return '合法长度为3-22个字符';
	} else if(floag2 == '-3'){
		return '用户名只能包含_,英文字母，数字';
	} else if(floag2 == '-4'){
		return '用户名只能英文字母开头';
	} else if(floag2 == '-5'){
		return '用户名只能英文字母或数字结尾';
	}
	return '';
}


/**
 *手机号码格式化 
 */
function getPhoneFormat(phone){
    if ((!phone) || phone.length <= 0) {
        return phone;
    }
    if (!isPhone(phone)) {
        return phone;
    }
    
    var a1 = phone.substr(0,3);
    var a2 = phone.substr(7,4);
    var nphone = a1+"****"+a2;
    return nphone;
}

/**
 * 获得当前日期
 */
function getNowDateTime(formatstr){
	var str = formatstr;
	var Week = ['日','一','二','三','四','五','六'];
	var mydate = new Date();
	str=str.replace(/yyyy|YYYY/,mydate.getFullYear());
	str=str.replace(/yy|YY/,(mydate.getYear() % 100)>9?(mydate.getYear() % 100).toString():'0' + (mydate.getYear() % 100));
	str=str.replace(/MM/,(mydate.getMonth()+1)>9?(mydate.getMonth()+1).toString():'0' + (mydate.getMonth()+1));
	str=str.replace(/M/g,mydate.getMonth());
	str=str.replace(/w|W/g,Week[mydate.getDay()]);
	str=str.replace(/dd|DD/,mydate.getDate()>9?mydate.getDate().toString():'0' + mydate.getDate());
	str=str.replace(/d|D/g,mydate.getDate());
	str=str.replace(/hh|HH/,mydate.getHours()>9?mydate.getHours().toString():'0' + mydate.getHours());
	str=str.replace(/h|H/g,mydate.getHours());
	str=str.replace(/mm/,mydate.getMinutes()>9?mydate.getMinutes().toString():'0' + mydate.getMinutes());
	str=str.replace(/m/g,mydate.getMinutes());
	str=str.replace(/ss|SS/,mydate.getSeconds()>9?mydate.getSeconds().toString():'0' + mydate.getSeconds());
	str=str.replace(/s|S/g,mydate.getSeconds());
	
	return str;
}

/**
 * 获得银行卡格式化
 */
function getBankNoFormat(bankcardaccount){
    if (!bankcardaccount) {
        return bankcardaccount;
    }
    if (!isBankNo(bankcardaccount)) {
        return bankcardaccount;
    }
    /*
    var a1 = bankcardaccount.substr(12,4);
    var a2 = bankcardaccount.substr(16);
    var nbankcardaccount = "**** **** **** "+a1+" "+a2;
    */
    var a1 = bankcardaccount.substr(-4);
    var nbankcardaccount = "**** **** **** "+a1;
    return nbankcardaccount;
    
}

/**
 * 获得银行卡图片
 */
function getBankImgClass(name){
    
    if (name == '中国银行') {
        return "icon-bank-zhongguo";
    } else if (name == '北京银行') {
        return "icon-bank-beijing";
    } else if (name == '工商银行') {
        return "icon-bank-gongshang";
    } else if (name == '广发银行') {
        return "icon-bank-guangfa";
    } else if (name == '华夏银行') {
        return "icon-bank-huaxia";
    } else if (name == '建设银行') {
        return "icon-bank-jianshe";
    } else if (name == '交通银行') {
        return "icon-bank-jiaotong";
    } else if (name == '民生银行') {
        return "icon-bank-minsheng";
    } else if (name == '农业银行') {
        return "icon-bank-nongye";
    } else if (name == '浦发银行') {
        return "icon-bank-pufa";
    } else if (name == '兴业银行') {
        return "icon-bank-xingye";
    } else if (name == '邮政银行') {
        return "icon-bank-youzheng";
    } else if (name == '招商银行') {
        return "icon-bank-zhaoshang";
    } else if (name == '中信银行') {
        return "icon-bank-zhongxin";
    } 
}



/**
 *流程状态
 */
function getlookTxt(stageid){
    if (stageid == '1') {
        return '新建评估';
    } else if (stageid == '2') {
        return '实审重估';
    } else if (stageid == '3') {
        return '转当评估';
    } else {
        return '新建评估';
    }
}


/*
 * 检查快递单号
 */
function checkKuaiDi(danhao)
{
    var companyReg = new Array();
    companyReg[0] = /^[0-9]{12}$/;
    companyReg[1] = /^[a-z-A-Z]{2}[0-9]{9}[a-z-A-Z]{2}$/;
    companyReg[2] = /^[0-9]{12}$/;
    companyReg[3] = /^[a-z-A-Z-0-9]{10}$/;
    companyReg[4] = /^[0-9]{13}$/;
    companyReg[5] = /^[0-9]{12}$/;
    companyReg[6] = /^[0-9]{14}$/;
    companyReg[7] = /^[0-9]{10}$/;
    
    //
    companyReg[8] = /[a-zA-Z0-9]+/;
    var msg = new Array();
    msg[0] = '申通快递单号由12位数字组成,目前常见以268**、368**、58**等开头.';
    msg[1] = 'EMS单号由13位字母和数字组成,一般开头和结尾二位是字母,中间是数字.';
    msg[2] = '顺丰速递单号由12位数字组成,目前常见以电话区号后三位开头.';
    msg[3] = '圆通快递单号由10位字母数字组成,目前常见以1*、2*、6*、8*、V*等开头.';
    msg[4] = '韵达快递单号由13位数字组成,目前常见以10*、12*、19*等开头.';
    msg[5] = '中通快递单号由12位数字组成,目前常见以2008**、6**、010等开头.';
    msg[6] = '天天快递单号由14位数字组成,目前常见以6**、5*、00*等开头.';
    msg[7] = '宅急送单号由10位数字组成,目前常见以7**、6**、5**等开头.'; 
    
    
    //var index = parseInt(mail.val()); //快递下拉框选择索引
    var index = 8;
    if (!companyReg[index].exec(danhao)) {  //no 是快递编号
        //alert("物流编号格式不正确\n" + msg[index]);
        //alert("物流编号格式不正确");
        //no.focus();
        return false;
    }   
    
    return true; 
}

